'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var dayjs = require('dayjs');
var vueScrollPicker = require('vue-scroll-picker');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var dayjs__default = /*#__PURE__*/_interopDefaultLegacy(dayjs);

const DEFAULT_MIN_DATE = '1970-01-01 00:00:00';

const MONTH_UNIT = 12;
const HOUR_UNIT = 24;
const MINUTE_UNIT = 60;

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function createCommonjsModule(fn) {
  var module = { exports: {} };
	return fn(module, module.exports), module.exports;
}

var customParseFormat = createCommonjsModule(function (module, exports) {
!function(t,e){module.exports=e();}(commonjsGlobal,(function(){var t={LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},e=/(\[[^[]*\])|([-:/.()\s]+)|(A|a|YYYY|YY?|MM?M?M?|Do|DD?|hh?|HH?|mm?|ss?|S{1,3}|z|ZZ?)/g,n=/\d\d/,r=/\d\d?/,i=/\d*[^\s\d-_:/()]+/,o={},s=function(t){return (t=+t)+(t>68?1900:2e3)};var a=function(t){return function(e){this[t]=+e;}},f=[/[+-]\d\d:?(\d\d)?|Z/,function(t){(this.zone||(this.zone={})).offset=function(t){if(!t)return 0;if("Z"===t)return 0;var e=t.match(/([+-]|\d\d)/g),n=60*e[1]+(+e[2]||0);return 0===n?0:"+"===e[0]?-n:n}(t);}],u=function(t){var e=o[t];return e&&(e.indexOf?e:e.s.concat(e.f))},h=function(t,e){var n,r=o.meridiem;if(r){for(var i=1;i<=24;i+=1)if(t.indexOf(r(i,0,e))>-1){n=i>12;break}}else n=t===(e?"pm":"PM");return n},d={A:[i,function(t){this.afternoon=h(t,!1);}],a:[i,function(t){this.afternoon=h(t,!0);}],S:[/\d/,function(t){this.milliseconds=100*+t;}],SS:[n,function(t){this.milliseconds=10*+t;}],SSS:[/\d{3}/,function(t){this.milliseconds=+t;}],s:[r,a("seconds")],ss:[r,a("seconds")],m:[r,a("minutes")],mm:[r,a("minutes")],H:[r,a("hours")],h:[r,a("hours")],HH:[r,a("hours")],hh:[r,a("hours")],D:[r,a("day")],DD:[n,a("day")],Do:[i,function(t){var e=o.ordinal,n=t.match(/\d+/);if(this.day=n[0],e)for(var r=1;r<=31;r+=1)e(r).replace(/\[|\]/g,"")===t&&(this.day=r);}],M:[r,a("month")],MM:[n,a("month")],MMM:[i,function(t){var e=u("months"),n=(u("monthsShort")||e.map((function(t){return t.substr(0,3)}))).indexOf(t)+1;if(n<1)throw new Error;this.month=n%12||n;}],MMMM:[i,function(t){var e=u("months").indexOf(t)+1;if(e<1)throw new Error;this.month=e%12||e;}],Y:[/[+-]?\d+/,a("year")],YY:[n,function(t){this.year=s(t);}],YYYY:[/\d{4}/,a("year")],Z:f,ZZ:f};function c(n){var r,i;r=n,i=o&&o.formats;for(var s=(n=r.replace(/(\[[^\]]+])|(LTS?|l{1,4}|L{1,4})/g,(function(e,n,r){var o=r&&r.toUpperCase();return n||i[r]||t[r]||i[o].replace(/(\[[^\]]+])|(MMMM|MM|DD|dddd)/g,(function(t,e,n){return e||n.slice(1)}))}))).match(e),a=s.length,f=0;f<a;f+=1){var u=s[f],h=d[u],c=h&&h[0],l=h&&h[1];s[f]=l?{regex:c,parser:l}:u.replace(/^\[|\]$/g,"");}return function(t){for(var e={},n=0,r=0;n<a;n+=1){var i=s[n];if("string"==typeof i)r+=i.length;else {var o=i.regex,f=i.parser,u=t.substr(r),h=o.exec(u)[0];f.call(e,h),t=t.replace(h,"");}}return function(t){var e=t.afternoon;if(void 0!==e){var n=t.hours;e?n<12&&(t.hours+=12):12===n&&(t.hours=0),delete t.afternoon;}}(e),e}}return function(t,e,n){n.p.customParseFormat=!0,t&&t.parseTwoDigitYear&&(s=t.parseTwoDigitYear);var r=e.prototype,i=r.parse;r.parse=function(t){var e=t.date,r=t.utc,s=t.args;this.$u=r;var a=s[1];if("string"==typeof a){var f=!0===s[2],u=!0===s[3],h=f||u,d=s[2];u&&(d=s[2]),o=this.$locale(),!f&&d&&(o=n.Ls[d]),this.$d=function(t,e,n){try{if(["x","X"].indexOf(e)>-1)return new Date(("X"===e?1e3:1)*t);var r=c(e)(t),i=r.year,o=r.month,s=r.day,a=r.hours,f=r.minutes,u=r.seconds,h=r.milliseconds,d=r.zone,l=new Date,m=s||(i||o?1:l.getDate()),M=i||l.getFullYear(),Y=0;i&&!o||(Y=o>0?o-1:l.getMonth());var p=a||0,v=f||0,D=u||0,g=h||0;return d?new Date(Date.UTC(M,Y,m,p,v,D,g+60*d.offset*1e3)):n?new Date(Date.UTC(M,Y,m,p,v,D,g)):new Date(M,Y,m,p,v,D,g)}catch(t){return new Date("")}}(e,a,r),this.init(),d&&!0!==d&&(this.$L=this.locale(d).$L),h&&e!=this.format(a)&&(this.$d=new Date("")),o={};}else if(a instanceof Array)for(var l=a.length,m=1;m<=l;m+=1){s[1]=a[m-1];var M=n.apply(this,s);if(M.isValid()){this.$d=M.$d,this.$L=M.$L,this.init();break}m===l&&(this.$d=new Date(""));}else i.call(this,t);};}}));
});

var utils = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.getJpEra = exports.getJpYear = void 0;
exports.getJpYear = function (date) {
    var result;
    try {
        result = Intl.DateTimeFormat('ja-JP-u-ca-japanese', {
            year: '2-digit',
            era: 'long'
        }).format(date).slice(0, -1);
    }
    catch (_a) {
        result = '該当なし';
    }
    return result;
};
exports.getJpEra = function (date) {
    var result;
    try {
        result = Intl.DateTimeFormat('ja-JP-u-ca-japanese', {
            era: 'long'
        }).format(date).slice(0, 2);
    }
    catch (_a) {
        result = '不明';
    }
    return result;
};
});

var dist = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.jpFormat = void 0;

exports.jpFormat = function (_o, c) {
    var proto = c.prototype;
    var oldFormat = proto.format;
    proto.format = function (formatStr) {
        var _this = this;
        var result = formatStr.replace(/\[([^\]]+)]|r+|/g, function (match) {
            switch (match) {
                case 'rrrr':
                    return utils.getJpYear(_this.toDate());
                case 'rr':
                    return utils.getJpEra(_this.toDate());
                default:
                    return match;
            }
        });
        return oldFormat.bind(this)(result);
    };
};
});

dayjs__default["default"].extend(customParseFormat);
dayjs__default["default"].extend(dist.jpFormat);

const match = (pattern, format, index = 0) => {
  const match = format.match(pattern);
  return match ? match[index] : ''
};

const calculatePattern = format => {
  return {
    year: match(/Y+/, format),
    month: match(/M+/, format),
    date: match(/D+/, format),
    hour: match(/H+/i, format),
    minute: match(/m+/, format),
    dividerDate: match(/[YMD]+([^YMD]*)[YMD]+/, format, 1),
    dividerTime: match(/[Hms]+([^Hms]*)[Hms]+/, format, 1),
  }
};

/**
 * @param {string} baseFormat
 * @return {array}
 */
const guessDateOrder = (baseFormat) => {
  return [
    { type: 'year', index: baseFormat.indexOf('Y') },
    { type: 'month', index: baseFormat.indexOf('M') },
    { type: 'date', index: baseFormat.indexOf('D') },
  ]
    .sort((a, b) => a.index - b.index)
    .map(item => item.type)
};

const calculateWidth = str => {
  let result = 0;
  for (let i = 0; i < str.length; i++) {
    const chr = str.charCodeAt(i);
    if ((chr >= 0x00 && chr < 0x81) ||
      (chr === 0xf8f0) ||
      (chr >= 0xff61 && chr < 0xffa0) ||
      (chr >= 0xf8f1 && chr < 0xf8f4)) {
      result += 0.6;
    } else {
      result += 1;
    }
  }

  return result
};

/**
 * Format date string
 *
 * @param {string|number|Date} value
 * @param {string|undefined} modelFormat
 * @param {string} type
 * @return {string|undefined}
 */
const datestring = (value, modelFormat, type) => {
  if (!value) return undefined

  const baseFormat = '^' + modelFormat
    .replace(/(Aa|M{3,4}|d{2,4})/g, '[\\u\\l]+?')
    .replace(/([YMDHms])/g, '\\d');
  const format = new RegExp(baseFormat);
  if (format.test(value)) {
    const modelValue = dayjs__default["default"](value, modelFormat);
    if (modelValue.isValid()) {
      return modelValue.format(modelFormat)
    } else if (type === 'time' && typeof value === 'string') {
      const datetime = `1980-01-01 ${value}`;
      const date = dayjs__default["default"](datetime, `YYYY-MM-DD ${modelFormat}`);
      return date.isValid() ? datetime : undefined
    }
    return undefined
  } else {
    return undefined
  }
};

var useBindings = {
  props: {
    align: { type: String, default: 'center' },
    defaultValue: { type: String, default: undefined },
    pattern: { type: Object, default: undefined },
    format: { type: [String, Object], default: undefined },
    value: { type: [String, Number, Date], default: undefined },
  },
  computed: {
    modelValue: {
      get () {
        const modelValue = this.value || this.defaultValue || dayjs__default["default"]().format(this.modelFormat);
        return datestring(modelValue, this.modelFormat, this.type)
      },
      set (value) {
        const valueObj = dayjs__default["default"](value, this.format);
        if (this.minDate && valueObj.isBefore(this.minDate)) value = this.minDate;
        if (this.maxDate && valueObj.isAfter(this.maxDate)) value = this.maxDate;

        this.$emit('input', value);
      },
    },
    modelFormat () {
      if (this.format) return this.format
      switch (this.type) {
        case 'datetime': return 'YYYY-MM-DD HH:mm'
        case 'date': return 'YYYY-MM-DD'
        case 'time': return 'HH:mm'
        default: throw new Error('Invalid property. "type" is only allow "datetime/date/time".')
      }
    },
    drumPattern () {
      return {
        ...calculatePattern(this.modelFormat),
        ...(this.pattern || {}),
      }
    },
  },
  methods: {
    onInput (value) {
      if (dayjs__default["default"].unix(value).isBefore(this.minDate)) {
        this.modelValue = datestring(this.minDate, this.modelFormat, this.type);
      } else if (this.maxDate && dayjs__default["default"](value).isAfter(this.maxDate)) {
        this.modelValue = datestring(this.maxDate, this.modelFormat, this.type);
      } else {
        this.modelValue = datestring(value, this.modelFormat, this.type);
      }
    },

    onNativeInput (event) {
      const value = datestring(event.target.value, this.modelFormat, this.type);
      if (value) this.modelValue = value;
    },
  },
};

var OverlayLayer = {
  name: 'OverlayLayer',
  functional: true,
  props: {
    dark: { type: Boolean, default: false },
  },
  render (h, context) {
    return h('div', {
      class: [
        'v-drumroll-picker__overlay',
        context.props.dark ? '--dark' : '',
      ],
      on: {
        click: context.listeners.click,
      },
    })
  },
};

// Material Design Icons v5.9.55
var mdiCheckBold = "M9,20.42L2.79,14.21L5.62,11.38L9,14.77L18.88,4.88L21.71,7.71L9,20.42Z";

var ConfirmButton = {
  name: 'ConfirmButton',

  functional: true,

  props: {
    size: { type: [Number, String], default: 24 },
  },

  render (h, { props, listeners }) {
    const icon = h('svg',
      {
        class: ['v-drumroll-picker__button--icon'],
        style: {
          height: `${props.size}px`,
          width: `${props.size}px`,
        },
        attrs: {
          viewBox: '0 0 24 24',
        },
      },
      [h('path', {
        attrs: { d: mdiCheckBold },
      })],
    );

    return h('button', {
      class: ['v-drumroll-picker__button'],
      on: { ...listeners },
    }, [icon])
  },
};

const pickerLayer = h => (
  h('div', { class: ['vue-scroll-picker-layer'] }, [
    h('div', { class: ['top'], ref: 'top' }),
    h('div', { class: ['middle'], ref: 'selection' }),
    h('div', { class: ['bottom'], ref: 'bottom' }),
  ])
);

const confirmButton = (h, { props, listeners }) => (
  !props.dialog || props.hideButton
    ? [] : [h(ConfirmButton, { on: listeners })]
);

var PickerContainer = {
  name: 'PickerContainer',

  functional: true,

  props: {
    dialog: { type: Boolean, default: false },
    height: { type: [Number, String], default: '10em' },
    hideButton: { type: Boolean, default: false },
  },

  render: (h, context) => (h('div',
    {
      class: 'v-drumroll-picker__container',
      style: {
        height: typeof context.props.height === 'string'
          ? context.props.height : context.props.height + 'px',
      },
    },
    [
      pickerLayer(h),
      ...context.children,
      pickerLayer(h),
      ...confirmButton(h, context),
    ],
  )),
};

const transitionLayer = (h, content) => (
  h('transition', {
    props: {
      name: 'v-drumroll-picker__slide-transition',
      mode: 'in-out',
      appear: true,
      duration: 300,
    },
  }, [content])
);

var ContentLayer = {
  name: 'ContentLayer',
  functional: true,
  render (h, context) {
    return transitionLayer(h, h('div', {
      class: 'v-drumroll-picker__content',
      on: { click: e => e.stopPropagation() },
    }, context.children))
  },
};

const disableScroll = (e) => {
  e.preventDefault();
  e.stopPropagation();
};

var useDialog = {
  props: {
    dialog: { type: Boolean, default: false },
    hideOverlay: { type: Boolean, default: false },
    hideButton: { type: Boolean, default: false },
  },

  data () {
    return {
      active: false,
    }
  },

  methods: {
    generateDialogPicker (h) {
      const content = [this.generateActivator(h)];

      if (this.active) {
        // overlay
        content.push(h(OverlayLayer, {
          props: { dark: !this.hideOverlay },
          on: { click: this.offActivate },
        }));

        // picker
        const picker = h(PickerContainer, {
          props: this.$props,
          on: { click: this.offActivate },
        }, [this.pickers(h)]);
        content.push(h(ContentLayer, [picker]));
      }
      return h('div', { class: ['v-drumroll-picker', 'v-drumroll-picker--dialog'] }, content)
    },

    generateActivator (h) {
      const on = {
        click: this.onActivate,
        focus: this.onActivate,
        touchend: this.onActivate,
      };

      if (this.$scopedSlots.activator) {
        return this.$scopedSlots.activator({ on })
      }

      // Fallback default
      const options = {
        class: 'v-drumroll-picker__input',
        domProps: { value: this.value },
        on: { input: this.onNativeInput, ...on },
      };
      return h('input', options)
    },

    /**
     * @param {KeyboardEvent} e
     */
    onClose (e) {
      if (e.key.toUpperCase() === 'ESCAPE') this.offActivate(e);
    },

    /**
     * @param {MouseEvent} e
     */
    onActivate (e) {
      e.preventDefault();

      // Close on ESC
      document.addEventListener('keydown', this.onClose);
      document.addEventListener('scroll', disableScroll, { passive: false });
      document.addEventListener('wheel', disableScroll, { passive: false });
      document.addEventListener('touchmove', disableScroll, { passive: false });

      // Blur active element.
      const isElement = document.activeElement instanceof HTMLElement;
      if (!this.active && !this.hideOverlay && isElement) document.activeElement.blur();

      // Emit initial value
      const modelFormat = this.format || this.modelFormat;
      const modelValue = this.value || this.defaultValue || dayjs__default["default"]().format(modelFormat);
      const initialValue = datestring(modelValue, modelFormat, this.type);
      this.$emit('input', initialValue);

      this.active = !this.active;
    },

    /**
     * @param {MouseEvent|KeyboardEvent} e
     */
    offActivate (e) {
      e.preventDefault();
      document.removeEventListener('keydown', this.onClose);
      document.removeEventListener('scroll', disableScroll);
      document.removeEventListener('wheel', disableScroll);
      document.removeEventListener('touchmove', disableScroll);
      this.active = false;
    },
  },
};

var useSensitivity = {
  props: {
    /**
     * Dependency library properties
     * @see https://github.com/wan2land/vue-scroll-picker
     */
    dragSensitivity: { type: [String, Number], default: 1.7 },
    touchSensitivity: { type: [String, Number], default: 1.7 },
    scrollSensitivity: { type: [String, Number], default: 0.8 },
  },
};

var DrumDivider = {
  name: 'DrumDivider',

  functional: true,

  props: {
    divider: { type: String, required: true },
  },

  render (h, { props }) {
    return h('span', { class: 'v-drumroll-picker__divider -selected' }, [props.divider])
  },
};

var BasePicker = {
  name: 'BasePicker',

  functional: true,

  mixins: [
    useSensitivity,
  ],

  props: {
    align: { type: String, default: 'center' },
    items: { type: Array, required: true },
    format: { type: String, required: true },
    height: { type: [String, Number], default: '10em' },
    unit: { type: String, required: true },
    value: { type: [String, Number], default: undefined },
    width: { type: [String, Number], default: '2em' },
  },

  render (h, { props, listeners }) {
    return h(vueScrollPicker.ScrollPicker, {
      style: {
        '--picker-align': props.align,
        height: typeof props.height === 'string' ? props.height : props.height + 'px',
        width: typeof props.width === 'string' ? props.width : props.width + 'px',
      },
      props: {
        options: props.items,
        dragSensitivity: props.dragSensitivity,
        touchSensitivity: props.touchSensitivity,
        scrollSensitivity: props.scrollSensitivity,
        value: dayjs__default["default"](props.value, props.format).get(props.unit),
      },
      on: {
        input: value => {
          if (!value) value = 0;

          const dateObj = props.value ? dayjs__default["default"](props.value, props.format) : dayjs__default["default"]();
          const current = dateObj.get(props.unit);
          const date = dateObj.set(props.unit, value);

          // 桁上がり抑止
          if (current <= value && date.get(props.unit) < value) return
          listeners.input(date.unix());
        },
      },
    })
  },
};

var BaseDatePicker = {
  name: 'BaseDatePicker',

  mixins: [useSensitivity],

  props: {
    align: { type: String, default: 'center' },
    dateOrder: { type: Array, default: undefined },
    defaultValue: { type: String, default: undefined },
    drumPattern: { type: Object, required: true },
    format: { type: [String, Object], default: 'YYYY-MM-DD' },
    height: { type: [String, Number], default: undefined },
    maxDate: { type: [String, Number, Date], default: undefined },
    minDate: { type: [String, Number, Date], default: DEFAULT_MIN_DATE },
    separator: { type: String, default: undefined }, // deprecated
    value: { type: [String, Number, Date], default: undefined },
  },

  data () {
    const date = dayjs__default["default"](this.value || this.defaultValue, this.format).endOf('month').date();
    return {
      date: date,
      numberOfDays: date,
      dateOfMin: 1,
    }
  },

  computed: {
    formatDefaultValue () {
      return dayjs__default["default"](this.defaultValue).format(this.format)
    },

    /**
     * 年配列
     *
     * @return {array}
     */
    years () {
      const value = this.value || this.defaultValue;
      const minYear = dayjs__default["default"](this.minDate).year();
      const maxYear = this.maxDate
        ? dayjs__default["default"](this.maxDate).year()
        : dayjs__default["default"](value, this.format).add(100, 'year').year();

      const years = [];
      const dateObj = dayjs__default["default"](value, this.format);
      for (let year = minYear; year <= maxYear; year++) {
        years.push({
          name: dateObj.set('year', year).format(this.drumPattern.year),
          value: year,
        });
      }

      return years
    },

    /**
     * 月配列
     *
     * @return {array}
     */
    months () {
      const value = this.value || this.defaultValue;
      const currentDate = dayjs__default["default"](value, this.format);
      const minDate = dayjs__default["default"](this.minDate);
      let min = currentDate.isSame(minDate, 'year') ? minDate.month() : 0;
      let max = this.maxDate && currentDate.isSame(this.maxDate, 'year')
        ? dayjs__default["default"](this.maxDate).month() + 1
        : MONTH_UNIT;

      if (min > currentDate.month() || max < currentDate.month()) {
        min = 0;
        max = MONTH_UNIT;
      }

      // 桁揃えをしつつ時刻を配列に追加
      const months = [];
      const dateObj = dayjs__default["default"](value, this.format);
      for (let month = min; month < max; month++) {
        months.push({
          name: dateObj.set('month', month).format(this.drumPattern.month),
          value: month,
        });
      }

      return months
    },

    /**
     * 日配列
     *
     * @params {string} date
     * @return {array}
     */
    days () {
      const value = this.value || this.defaultValue;
      const currentDate = dayjs__default["default"](value, this.format);
      const minDate = dayjs__default["default"](this.minDate);
      let min = currentDate.isSame(minDate, 'month') ? minDate.date() : 1;
      let max = this.maxDate && currentDate.isSame(this.maxDate, 'month')
        ? dayjs__default["default"](this.maxDate).date()
        : this.numberOfDays;

      if (min > currentDate.date() || max < currentDate.date()) {
        min = 1;
        max = this.numberOfDays;
      }

      // 桁揃えをしつつ時刻を配列に追加
      const days = [];
      const dateObj = currentDate.clone();
      for (let date = Math.min(this.dateOfMin, min); date <= max; date++) {
        days.push({
          name: date <= this.date && date >= min ? dateObj.set('date', date).format(this.drumPattern.date) : '',
          value: date,
        });
      }

      this.$nextTick(() => setTimeout(() => {
        this.dateOfMin = min;
        if (this.date !== this.numberOfDays) {
          this.numberOfDays = this.date;
        }
      }, 100));

      return days
    },
  },

  watch: {
    value (newValue) {
      const newDate = dayjs__default["default"](newValue, this.format);
      const lastDate = newDate.endOf('month').date();
      if (lastDate !== this.date) this.date = lastDate;
    },
  },

  methods: {
    onInput (value) {
      if (!value) return

      const valueObj = dayjs__default["default"].unix(value);
      if (this.value || valueObj.format(this.format) !== this.formatDefaultValue) {
        this.$emit('input', valueObj.format(this.format));
      }
    },
  },

  render (h) {
    const divider = this.separator || this.drumPattern.dividerDate || this.drumPattern['divider-date'];
    const drumDivider = divider ? h(DrumDivider, { props: { divider } }) : null;
    const sampleDate = dayjs__default["default"]('1989-12-31');

    const drums = {
      year: h(BasePicker, {
        props: {
          items: this.years,
          unit: 'year',
          width: calculateWidth(sampleDate.format(this.drumPattern.year)) + 'em',
          ...this.$props,
          value: this.value || this.defaultValue,
        },
        on: {
          input: this.onInput,
        },
      }),
      month: h(BasePicker, {
        props: {
          items: this.months,
          unit: 'month',
          width: calculateWidth(sampleDate.format(this.drumPattern.month)) + 'em',
          ...this.$props,
          value: this.value || this.defaultValue,
        },
        on: {
          input: this.onInput,
        },
      }),
      date: h(BasePicker, {
        props: {
          items: this.days,
          unit: 'date',
          width: calculateWidth(sampleDate.format(this.drumPattern.date)) + 'em',
          ...this.$props,
          value: this.value || this.defaultValue,
        },
        on: {
          input: this.onInput,
        },
      }),
    };

    const pickers = [];
    const dateOrder = this.dateOrder || guessDateOrder(this.format);
    for (let i = 0; i < dateOrder.length; i++) {
      pickers.push(drums[dateOrder[i]]);
      if (divider && i < dateOrder.length - 1) pickers.push(drumDivider);
    }

    return h(vueScrollPicker.ScrollPickerGroup, { class: 'vdd-flex' }, pickers)
  },
};

var BaseTimePicker = {
  name: 'BaseTimePicker',

  mixins: [useSensitivity],

  props: {
    align: { type: String, default: 'center' },
    defaultValue: { type: String, default: undefined },
    drumPattern: { type: Object, required: true },
    format: { type: String, default: 'YYYY-MM-DD HH:mm' },
    height: { type: [String, Number], default: undefined },
    maxDate: { type: [String, Number, Date], default: undefined },
    minDate: { type: [String, Number, Date], default: undefined },
    minuteInterval: { type: [String, Number], default: 1 },
    separator: { type: String, default: undefined }, // deprecated
    value: { type: [String, Number, Date], default: undefined },
  },

  computed: {
    formatDefaultValue () {
      return dayjs__default["default"](this.defaultValue).format(this.format)
    },

    /**
     * 時配列
     *
     * @return {array}
     */
    hours () {
      let min = 0;
      let max = HOUR_UNIT;

      const value = this.value || this.defaultValue;
      const currentDate = value ? dayjs__default["default"](value, this.format) : dayjs__default["default"]();

      if (this.minDate) {
        const minDate = dayjs__default["default"](this.minDate);
        min = currentDate.isSame(minDate, 'date') ? minDate.hour() : 0;
      }
      if (this.maxDate) {
        max = this.maxDate && currentDate.isSame(this.maxDate, 'date')
          ? dayjs__default["default"](this.maxDate).hour() + 1 : HOUR_UNIT;
      }

      const hours = [];
      const dateObj = currentDate.clone();
      for (let hour = min; hour < max; hour++) {
        hours.push({
          name: dateObj.set('hour', hour).format(this.drumPattern.hour),
          value: hour,
        });
      }
      return hours
    },

    /**
     * 分配列
     *
     * @return {array}
     */
    minutes () {
      let min = 0;
      let max = MINUTE_UNIT;

      const value = this.value || this.defaultValue;
      const currentDate = value ? dayjs__default["default"](value, this.format) : dayjs__default["default"]();

      if (this.minDate) {
        const minDate = dayjs__default["default"](this.minDate);
        min = currentDate.isSame(minDate, 'hour') ? minDate.minute() : 0;
      }
      if (this.maxDate) {
        max = this.maxDate && currentDate.isSame(this.maxDate, 'hour')
          ? dayjs__default["default"](this.maxDate).minute() + 1
          : MINUTE_UNIT;
      }

      const interval = Number(this.minuteInterval);
      const minutes = [];
      const dateObj = currentDate.clone();
      for (let minute = min; minute < max; minute += interval) {
        minutes.push({
          name: dateObj.set('minute', minute).format(this.drumPattern.minute),
          value: minute,
        });
      }
      return minutes
    },
  },

  methods: {
    onInput (value) {
      if (value && (this.value || dayjs__default["default"].unix(value).format(this.format) !== this.formatDefaultValue)) {
        this.$emit('input', dayjs__default["default"].unix(value).format(this.format));
      }
    },
  },

  render (h) {
    const divider = this.separator || this.drumPattern.dividerTime || this.drumPattern['divider-time'];
    const drumDivider = divider ? h(DrumDivider, { props: { divider } }) : null;
    const sampleDate = dayjs__default["default"]('1989-12-31 10:10:10');

    // 時
    const hourPicker = h(BasePicker, {
      props: {
        ...this.$props,
        items: this.hours,
        unit: 'hour',
        width: calculateWidth(sampleDate.format(this.drumPattern.hour)) + 'em',
      },
      on: {
        input: this.onInput,
      },
    });

    // 分
    const minutePicker = h(BasePicker, {
      props: {
        ...this.$props,
        items: this.minutes,
        unit: 'minute',
        width: calculateWidth(sampleDate.format(this.drumPattern.minute)) + 'em',
      },
      on: {
        input: this.onInput,
      },
    });

    return h(vueScrollPicker.ScrollPickerGroup, { class: 'vdd-flex' }, [
      hourPicker,
      drumDivider,
      minutePicker,
    ])
  },
};

const generateDatePicker = (h, options) => (
  h(BaseDatePicker, options())
);

const generateTimePicker = (h, options) => (
  h(BaseTimePicker, options())
);

var DateTimePicker = {
  name: 'DateTimePicker',

  mixins: [
    useBindings,
    useDialog,
    useSensitivity,
  ],

  props: {
    dateOrder: { type: Array, default: undefined },
    height: { type: [String, Number], default: undefined },
    hideButton: { type: Boolean, default: false },
    maxDate: { type: [String, Number, Date], default: undefined },
    minDate: { type: [String, Number, Date], default: () => DEFAULT_MIN_DATE },
    minuteInterval: { type: [String, Number], default: 1 },
    type: { type: String, default: 'datetime' },
  },

  methods: {
    pickers (h) {
      const options = props => ({
        props: {
          ...this.$props,
          ...props,
          value: this.modelValue,
          format: this.modelFormat,
          drumPattern: this.drumPattern,
        },
        on: { input: this.onInput },
      });

      switch (this.type) {
        case 'datetime': return [generateDatePicker(h, options), generateTimePicker(h, options)]
        case 'date': return [generateDatePicker(h, options)]
        case 'time': return [generateTimePicker(h, options)]
      }
    },
  },

  render (h) {
    if (this.dialog) {
      return this.generateDialogPicker(h)
    } else {
      const container = h(PickerContainer, { props: this.$props }, [this.pickers(h)]);
      return h('div', { class: ['v-drumroll-picker'] }, [container])
    }
  },
};

var DatePicker = {
  name: 'DatePicker',

  mixins: [
    useBindings,
    useDialog,
    useSensitivity,
  ],

  props: {
    dateOrder: { type: Array, default: undefined },
    height: { type: [String, Number], default: undefined },
    hideButton: { type: Boolean, default: false },
    maxDate: { type: [String, Number, Date], default: undefined },
    minDate: { type: [String, Number, Date], default: () => DEFAULT_MIN_DATE },
    separator: { type: String, default: undefined }, // deprecated
  },

  computed: {
    type () {
      return 'date'
    },
  },

  methods: {
    pickers (h) {
      const options = () => ({
        props: {
          ...this.$props,
          value: this.modelValue,
          format: this.modelFormat,
          drumPattern: this.drumPattern,
        },
        on: { input: this.onInput },
      });

      return [h(BaseDatePicker, options())]
    },
  },

  render (h) {
    if (this.dialog) {
      return this.generateDialogPicker(h)
    } else {
      const props = {
        ...this.$props,
        value: this.modelValue,
        format: this.modelFormat,
        drumPattern: this.drumPattern,
      };
      const container = h(PickerContainer, { props }, [this.pickers(h)]);
      return h('div', { class: ['v-drumroll-picker'] }, [container])
    }
  },
};

var TimePicker = {
  name: 'TimePicker',

  mixins: [
    useBindings,
    useDialog,
    useSensitivity,
  ],

  props: {
    height: { type: [String, Number], default: undefined },
    hideButton: { type: Boolean, default: false },
    minuteInterval: { type: [String, Number], default: 1 },
    separator: { type: String, default: undefined }, // deprecated
  },

  computed: {
    type: () => 'time',
  },

  methods: {
    onInput (value) {
      this.modelValue = datestring(value, this.modelFormat, this.type);
    },

    pickers (h) {
      const options = () => ({
        props: {
          ...this.$props,
          value: this.modelValue,
          format: this.modelFormat,
          drumPattern: this.drumPattern,
        },
        on: { input: this.onInput },
      });

      return [h(BaseTimePicker, options())]
    },
  },

  render (h) {
    if (this.dialog) {
      return this.generateDialogPicker(h)
    } else {
      const props = {
        ...this.$props,
        value: this.modelValue,
        format: this.modelFormat,
        drumPattern: this.drumPattern,
      };
      const container = h(PickerContainer, { props }, [this.pickers(h)]);
      return h('div', { class: ['v-drumroll-picker'] }, [container])
    }
  },
};

exports.DatePicker = DatePicker;
exports.DateTimePicker = DateTimePicker;
exports.TimePicker = TimePicker;
exports["default"] = DateTimePicker;
